[![License](https://img.shields.io/badge/License-Apache%202.0-blue.svg)](https://github.com/codingapi/springboot-framework/blob/main/LICENSE)
[![Maven Central](https://img.shields.io/maven-central/v/com.codingapi.springboot/springboot-starter.svg?label=Maven%20Central)](https://search.maven.org/search?q=g:%22com.codingapi.springboot%22%20AND%20a:%22springboot-starter%22)
[![Build Status](https://app.travis-ci.com/codingapi/springboot-framework.svg?branch=main)](https://app.travis-ci.com/codingapi/springboot-framework)
[![codecov](https://codecov.io/gh/codingapi/springboot-framework/branch/main/graph/badge.svg?token=Gl9LjJV6y4)](https://codecov.io/gh/codingapi/springboot-framework)

# springboot-framework | Springboot领域驱动开发

> 当你无意间推开这一扇门，将会感叹原来生活可以如此的美好。

本框架基于springboot为提供领域驱动设计与事件风暴开发落地，提供的范式开源框架。

## maven install
```
    <dependency>
        <groupId>com.codingapi.springboot</groupId>
        <artifactId>springboot-starter</artifactId>
        <version>${last.version}</version>
    </dependency>
    
     <dependency>
        <groupId>com.codingapi.springboot</groupId>
        <artifactId>springboot-starter-leaf</artifactId>
        <version>${last.version}</version>
    </dependency>
    
     <dependency>
        <groupId>com.codingapi.springboot</groupId>
        <artifactId>springboot-starter-security-jwt</artifactId>
        <version>${last.version}</version>
     </dependency>
     
     <dependency>
        <groupId>com.codingapi.springboot</groupId>
        <artifactId>springboot-starter-data-permission</artifactId>
        <version>${last.version}</version>
     </dependency>
```

## CONTRIBUTING

Welcome to springboot-framework ! This document is a guideline about how to contribute to springboot-framework.
If you find something incorrect or missing, please leave comments / suggestions.

[CONTRIBUTING](./CONTRIBUTING.md)


## example
见springboot-example 完善中...

## youtube
欢迎订阅我的youtube账号 [codingapi](https://www.youtube.com/channel/UCdAsCAxh453D7MfLfYWj0Eg),带你从0到1落地springboot与领域驱动设计

[领域驱动设计001--了解为什么采用领域驱动设计开发](https://www.youtube.com/watch?v=09uP_sMvhY8)     
[领域驱动设计002--SpringBoot DDD Example HelloWorld](https://www.youtube.com/watch?v=d7LnYy8rTYI&t=149s)    
[领域驱动设计003--事件风暴](https://www.youtube.com/watch?v=EiMvgIKT46I)   
[领域驱动设计004--领域边界](https://www.youtube.com/watch?v=l80I3LkvGdE)   
[领域驱动设计005--统一模型语言UML](https://www.youtube.com/watch?v=FESDalckNQ4)     
领域驱动设计006--领域建模    
领域驱动设计007--模型测试   
领域驱动设计008--模型集成  
领域驱动设计009--过程讲解  
领域驱动设计010--回顾总结   


## books
实战书籍正在编写中...

## 推荐DDD的三个理由
* 业务逻辑可视化
* 灵活的业务拓展性
* 轻量化的业务单元测试

## 领域驱动设计开发流程

* 事件风暴
* 划分子域
* 设计模型
* 单元测试
* 集成业务

## 推荐的框架与软件
### SpringJPA 
JPA是ORM框架，可以非常简单的与领域对象相关联。 https://spring.io/projects/spring-data-jpa
### StartUML
StartUML是UML设计软件。https://staruml.io/
### Mural
Mural 是用于画事件风暴图的软件。https://www.mural.co/ 


## Reference Documentation

For further reference, please consider the following sections:

* [Official Apache Maven documentation](https://maven.apache.org/guides/index.html)
* [Spring Boot Maven Plugin Reference Guide](https://docs.spring.io/spring-boot/docs/2.7.1/maven-plugin/reference/html/)
* [Create an OCI image](https://docs.spring.io/spring-boot/docs/2.7.1/maven-plugin/reference/html/#build-image)
* [Spring Security](https://docs.spring.io/spring-boot/docs/2.7.1/reference/htmlsingle/#web.security)
* [Spring Configuration Processor](https://docs.spring.io/spring-boot/docs/2.7.1/reference/htmlsingle/#appendix.configuration-metadata.annotation-processor)
* [Spring Web](https://docs.spring.io/spring-boot/docs/2.7.1/reference/htmlsingle/#web)
* [securing-web](https://spring.io/guides/gs/securing-web/)
* [spring-security-without-the-websecurityconfigureradapter](https://spring.io/blog/2022/02/21/spring-security-without-the-websecurityconfigureradapter)
* [springboot-security&jwt](https://blog.csdn.net/u014553029/article/details/112759382)  
* [Meituan-Dianping/Leaf](https://github.com/Meituan-Dianping/Leaf)
